unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Win97izer;

type
  TfrmDelEureka = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    txtMousePos: TEdit;
    Label2: TLabel;
    txtWinClass: TEdit;
    Label3: TLabel;
    txtIsPassWord: TEdit;
    Label4: TLabel;
    txtPassword: TEdit;
    Win97izer1: TWin97izer;
    Win97izer2: TWin97izer;
    Win97izer3: TWin97izer;
    Win97izer4: TWin97izer;
    cbStartCapturing: TCheckBox;
    myTimer: TTimer;
    btClose: TSpeedButton;
    btAbout: TSpeedButton;
    cbStayOnTop: TCheckBox;
    procedure myTimerTimer(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure cbStayOnTopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btAboutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure WinMsgHandler( var Msg : TMsg; var Handled : Boolean );
  end;

var
  frmDelEureka: TfrmDelEureka;

const
       WM_ABOUT = WM_USER + 1;   { About message }

implementation

{$R *.DFM}

function StartsWith (const StartString, theString: string):Boolean;
begin
   if Copy(theString, 1, length(StartString)) = StartString then
     StartsWith := True
   else
     StartsWith := False
end;

procedure AppendToSystemMenu(Form: TForm;Item: string; ItemID: Word);
 var
   NormalSysMenu, MinimizedMenu: HMenu;
   AItem: array[0..255] of Char;
   PItem: PChar;
 begin
   NormalSysMenu := GetSystemMenu(Form.Handle, false);
   MinimizedMenu := GetSystemMenu(Application.Handle, false);
   if StartsWith('-', Item) then
    Begin
     AppendMenu(NormalSysMenu, MF_SEPARATOR, 0, nil);
     AppendMenu(MinimizedMenu, MF_SEPARATOR, 0, nil);
   end
   else
   begin
     PItem := StrPCopy(PChar(@AItem), Item);
     AppendMenu(NormalSysMenu, MF_STRING, ItemID, PItem);
     AppendMenu(MinimizedMenu, MF_STRING, ItemID, PItem);
   end
 end; 

procedure TfrmDelEureka.WinMsgHandler( var Msg : TMsg; var Handled : Boolean );
begin
   If Msg.Message = WM_SYSCOMMAND then
   begin
       if Msg.wParam = WM_ABOUT then
           Application.MessageBox('                             DelEureka 0.1'+ #13#10 +#13#10+
                        ' By Guru Ramnath.K (gururamnath@mailcity.com)'+ #13#10 + #13#10+
                        'Adapted (No..No..Actually Converted) from Tom Archer''s (tma-ng@mindspring.com) Work Eureka ! in VC++','About DelEureka...',0);
  End;
End;

procedure TfrmDelEureka.myTimerTimer(Sender: TObject);
Var
  winPoint:TPoint;
  myHandle: HWND;
  charClassName,charPassText: array[0..255] of char;
  lStyle:LongInt;

begin
        if cbStartCapturing.Checked = false then
        Begin
           txtMousePos.Text:='Capture Disabled';
           txtWinClass.Text:='Capture Disabled';
           txtPassword.Text:='Capture Disabled';
           txtIsPassWord.Text:='No';
           Exit;
        End;

        GetCursorPos(winPoint);
        txtMousePos.Text:= Format('X = %d, Y = %d', [winPoint.x, winPoint.y]);
        myHandle:=WindowFromPoint(winPoint);

        if Application.Handle = myHandle then
            exit;

        txtWinClass.Text:='(Self)';
        txtPassword.Text:='';
        txtIsPassWord.Text:='No';

        GetClassName(myHandle,@charClassName,255);
        txtWinClass.Text:=charClassName;
        lStyle:=GetWindowLong(myHandle,GWL_STYLE);

        if (lStyle and ES_PASSWORD) > 0 then
        Begin
            txtIsPassWord.Text:='Yes';
            SendMessage(myHandle, WM_GETTEXT, 255,lParam(@CharPassText));
            txtPassword.Text:=CharPassText;
        End;

end;

procedure TfrmDelEureka.btCloseClick(Sender: TObject);
begin
     Close;
end;

procedure TfrmDelEureka.cbStayOnTopClick(Sender: TObject);
begin
        if cbStayOnTop.Checked = true then
                SetWindowPos(Handle,
                   HWND_TOPMOST,
                   Left,
                   Top,
                   Width,
                   Height,
                   SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE)
        Else
                SetWindowPos(Handle,
                   HWND_NOTOPMOST,
                   Left,
                   Top,
                   Width,
                   Height,
                   SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
end;

procedure TfrmDelEureka.FormCreate(Sender: TObject);
begin
   Application.OnMessage := WinMsgHandler;
   AppendMenu( GetSystemMenu( Self.Handle, False ),
       MF_SEPARATOR, 0, '');
   AppendMenu( GetSystemMenu( Self.Handle, False ), MF_BYPOSITION,
       WM_ABOUT, '&About Delruka ...' );
end;

procedure TfrmDelEureka.btAboutClick(Sender: TObject);
begin
           Application.MessageBox('                             DelEureka 0.1'+ #13#10 +#13#10+
                        ' By Guru Ramnath.K (gururamnath@mailcity.com)'+ #13#10 + #13#10+
                        'Adapted (No..No..Actually Converted) from Tom Archer''s (tma-ng@mindspring.com) Work Eureka ! in VC++','About DelEureka...',0);
end;

end.
